#ifndef MOO_SINGLE_APP_H
#define MOO_SINGLE_APP_H

#include <QLocalServer>
#include <QLocalSocket>

namespace moo {

class SingleApp : public QObject {
    Q_OBJECT
    QString appId;
    QString filename;
    bool disabled;
    QLocalServer *server;
    long pid;

public:
    SingleApp(const QString &id, int &argc, char **argv);
    ~SingleApp();

    bool isRunning() const;
    bool isDisabled() const;
    void run();
    long processId() const;

public Q_SLOTS:
    bool sendMessage(const QByteArray &message, int timeout = 3000);

private Q_SLOTS:
    void newConnection();

Q_SIGNALS:
    void messageReceived(const QByteArray &message);
};

} // namespace moo

#endif // MOO_SINGLE_APP_H
